;**************************     ***************
;     : 
;      RC-,
;   RA2,  RA0,RA1- 7-. 
;  ,
;RB0...RB6-  , RA3- \ ,
;RA4-  , RB7-  .

         list p=16F84a
         include "D:\radio\mplab\p16F84a.inc" 
         __CONFIG _CP_OFF &_WDT_OFF &_PWRTE_ON &_XT_OSC
;
;********************** *******************************
;
 
M_O_INIT     EQU 0xC3         ;b'11000011', OPTION. . .=16         
M_TA_INIT    EQU 0x08         ;b'00001000',  -TRISA
M_TB_INIT    EQU 0x00         ;b'00000000',  -TRISB
M_I_INIT     EQU 0xA0         ;b'10100000', INTCON
M_FLAG_INIT  EQU 0xFF         ;b'11111111',  
X_Pause      EQU 0xFE         ;   X
Y_Pause      EQU 0xFE         ;   Y
Z_Pause      EQU 0x05         ;   Z
Del_Range    EQU 0x82         ;  
Cycle_1      EQU 0xA0         ; .  (1024 )
Cycle_2      EQU 0x02         ; . .  (2)
Cycle_3      EQU 0xFF         ; .  (500ms)
Cycle_4      EQU 0x06         ;  (6s)      

;
;********************   **********************************
;
 
Ind_0        EQU 0x00           ; RA0, .  (1-.), Out 
Ind_1        EQU 0x01           ; RA1, .  (1-.) Out
C1_Rel       EQU 0x02           ; RA2, \  (In/Out)
TMR_On       EQU 0x03           ; RA3, /  (0), In
TMR_Run      EQU 0x04           ; RA4,  . , Out 
Led_On       EQU 0x07           ; RB7,    (1), Out

;
;**********************    *************************
;

Phase        EQU 0x07           ; : 0- ., 1-

;
;**************************  ************************************
;

Delay_Reg_1    EQU 0x0C          ;  
Delay_Reg_2    EQU 0x0D          ;  
Flags          EQU 0x0E          ;  
W_copy         EQU 0x0F          ;  w 
FSR_copy       EQU 0x10          ;  FSR 
STATUS_copy    EQU 0x11          ;  STATUS
X_Count        EQU 0x12          ;C  X
Y_Count        EQU 0x13          ;C  Y 
Z_Count        EQU 0x14          ;C  Z
R_Bits         EQU 0x15          ; (.), .  R1
N              EQU 0x16          ;  . One_Shot
Digit_0        EQU 0x17          ;.   
Digit_1        EQU 0x18          ;.      
Int_Count_Low  EQU 0x19          ;.  
Int_Count_High EQU 0x1A          ;.  
Ind_Nom        EQU 0x1B          ;   
Cell_1         EQU 0x1C          ;  
Cell_2         EQU 0x1D          ;  . 
Cell_3         EQU 0x1E
Cell_4         EQU 0x1F

;
;*****************  *******************************
;
        ORG 0                   ;    'Main'
        goto     Main        
        ORG 4                   ; 
        goto     Int_Prog       
       
;
;****************   *******************
;                                            
Main
	clrf     PORTA		     ;     
        clrf     PORTB               ;    
        clrf     TMR0                ; 
        bsf      STATUS,RP0          ;    1
        movlw    M_O_INIT            ;  
        movwf    OPTION_REG^80H      ;   OPTION_REG
        movlw    M_TA_INIT           ;  
        movwf    TRISA^80H           ;
        movlw    M_TB_INIT           ;  
        movwf    TRISB^80H           ;
        bcf      STATUS,RP0          ;  0
        movlw    M_I_INIT            ;  
        movwf    INTCON              ;   INTCON
        movlw    M_FLAG_INIT         ;  
        movwf    Flags               ;    Flags
	clrf     R_Bits              ; R_Bits
Test
        bcf      INTCON,7            ; 
	movlw    b'10000000'	     ;  LSB(HG1)   8
        movwf    PORTB               
        bsf      PORTA,0                                   
        call     Delay_1s            ; 1 
	bsf      PORTA,1             ;  MSB (HG2)  8 
        call     Delay_1s            ; 1 
        clrf     PORTA               ;   
        clrf     PORTB
	clrf     N                   ; N
        bsf      PORTA,TMR_Run
First_Pass      
	call     One_Shot            ; ,  
	call     Delay_100ms         ; 0,1
     
     
     
;
;******************    **********************
;
 
Get_Time
	bsf      Flags,Phase         ;  
        bcf      INTCON,7            ; 
        
	call     One_Shot            ;  'N'  
        movlw    0x03                ; .    
        movwf    PCLATH              ;   PCLATH
        movf     N,w                 
        call     Convert             ; 
	movwf    R_Bits              ;  
        clrf     PCLATH              ;PCLATH   
        call     Bin_to_BCD          ;  BCD 
        bsf      INTCON,7            ;   

;
;******************    SB1 **************************
;

Check_SB1
        btfsc    PORTA,TMR_On        ;   -
	goto     Get_Time            ;     
        call     Delay_100ms
        bcf      Flags,Phase         ;                  	            
        call     Delay_1s            ;,    SB1
        
;
;********************   ***************************************
;

Timer_On
	  
        clrf     Int_Count_Low       ;  
	clrf     Int_Count_High 
        
Time_Count
        bsf      PORTA,TMR_Run       ; VT1  
        btfss    PORTA,TMR_On        ;     
	goto     Reset_TMR           ;  SB1  
	movfw	 Int_Count_High      ;    15000 
	xorlw    0x3A                ; (3A98hex),  1.
	btfss    STATUS,Z
	goto     Time_Count
	movfw	 Int_Count_Low
	sublw    0x97
	btfsc    STATUS,C            
	goto     Time_Count          ; 1  - 
	decf     R_Bits,f            ;R_Bits=R_Bits-1.  
	btfsc    STATUS,Z            ;   (R_Bits=0),  
	bsf      Flags,Phase         ;    
        call     Bin_to_BCD          ; R_Bits  BCD-
        btfss    Flags,Phase         ;    -
	goto     Timer_On            ;     
	
;
;**************************   ****************************
;

Timer_Stop
        call     Delay_1s
        call     Beep 
	bsf      PORTA,TMR_Run        ; VT1  
Reset_TMR
        call     Delay_1s 
	clrf     R_Bits               ;  
	clrf     Int_Count_Low        ;  
	clrf     Int_Count_High
	bsf      Flags,Phase          ;  =1
        call     Delay_100ms
	goto     Get_Time             ;  

;
;********      BCD- *********
;      R_Bits,    Digit_0
; - ,  Digit_1 - . 

Bin_to_BCD
         clrf      Digit_1
         movfw     R_Bits
         movwf     Digit_0
G_Tens 
         movlw     d'10'
         subwf     Digit_0,w
         btfss     STATUS,C
         goto      Over
         movwf     Digit_0
         incf      Digit_1,f
         goto      G_Tens
Over
         movf      Digit_1,w              ;  
         andlw     b'00001111'
         btfss     STATUS,Z
         goto      Finish
         movlw     b'00010000'            ;d'16'-  16   
         movwf     Digit_1                ;  ( )
Finish
	 return

;
;******    7-   ********
; "0" -   , . .     

Table    
         addwf      PCL,f
         retlw      b'11000000'           ; "0"
         retlw      b'11111001'           ; "1"
         retlw      b'10100100'           ; "2"
         retlw      b'10110000'           ; "3"
         retlw      b'10011001'           ; "4"
         retlw      b'10010010'           ; "5"
         retlw      b'10000010'           ; "6"
         retlw      b'11111000'           ; "7"
         retlw      b'10000000'           ; "8"
         retlw      b'10010000'           ; "9"
         retlw      b'10001000'           ; ""
         retlw      b'10000011'           ; "B"
         retlw      b'11000110'           ; "C"
         retlw      b'10100001'           ; "D"
         retlw      b'10000110'           ; "E"
         retlw      b'10001110'           ; "F"
         retlw      b'11111111'           ;  ( 10h)
	 
;
;*********************    TMR0 ***********************
;

Int_Prog
        movwf   W_copy                    ; 
        movf    STATUS,w
        movwf   STATUS_copy
        movf    FSR,w
        movwf   FSR_copy
        bcf     INTCON,T0IF                ;  

        movlw   0x06                       ;  
        movwf   TMR0

        btfsc   Flags,Phase                ;  :
        goto    Clear                      ; - 

        movfw   Int_Count_Low              ;  LSB  
        xorlw   H'FF'                      ; -  .  
        BZ      Add_H                      ;
        incf    Int_Count_Low,f 
        goto    Indicate                   ;
Add_H 
        incf    Int_Count_High,f           ; MSB  
        clrf    Int_Count_Low
        movfw   Int_Count_High
        xorlw   H'FF'                      ; - 
        BZ      Clear
        goto    Indicate                   ;
Clear
        clrf    Int_Count_Low
        clrf    Int_Count_High
Indicate            
        bcf        PORTA,Ind_0            ; 
	bcf        PORTA,Ind_1
        incf       Ind_Nom,f              ;  (\)
        btfss      Ind_Nom,0              ;  - .  
	goto       LSB_Ind                ;  -
        goto       MSB_Ind
MSB_Ind
        movf       Digit_1,w              ; MSB  w
        call       Table                  ;  7-. 
	andwf      Flags,w                ;  7  
	movwf      PORTB                  ;  
        bsf        PORTA,Ind_1            ; 
	goto       End_Int
LSB_Ind
        movf       Digit_0,w              ; MSB  w                         
	call       Table                  ;  7-.                        
	andwf      Flags,w                ;  7                               
	movwf      PORTB                  ;                                
        bsf        PORTA,Ind_0            ;                                            
End_Int
        movf     FSR_copy,w               ; 
        movwf    FSR
        movf     STATUS_copy,w
        movwf    STATUS
        swapf    W_copy,f
        swapf    W_copy,w
        retfie

;
;******************  "One Shot" ********************************
;

One_Shot
	clrf     N
	bsf	 STATUS,RP0
	bsf      TRISA,2
	bcf      STATUS,RP0
Tst
	btfss    PORTA,C1_Rel
	goto     Ready
	incfsz   N,f
	goto     Tst
Ready
	decf     N,f
	movf     N,w
	xorlw    0xFF
	btfsc    STATUS,Z
	clrf     N      
	bsf      STATUS,RP0
	bcf      TRISA,2
	bcf      STATUS,RP0
	bsf      PORTA,C1_Rel
	return  

;
;**************************    1s *****************
;

Delay_1s                                     
        movlw  Z_Pause
        movwf  Z_Count
Z_Loop  
        movlw  Y_Pause
        movwf  Y_Count

Y_Loop  movlw  X_Pause
        movwf  X_Count

X_Loop  decfsz X_Count,f
        goto   X_Loop
        decfsz Y_Count,f
        goto   Y_Loop
        decfsz Z_Count,f
        goto   Z_Loop
        return            

;                 
;**************   100 ***************************
;

Delay_100ms
         movlw      Del_Range
         movwf      Delay_Reg_1
         movlw      h'FF'
         movwf      Delay_Reg_2
Loop     
         decfsz     Delay_Reg_2,f
         goto       Loop
         decfsz     Delay_Reg_1,f
         goto       Loop
         return

;
;*********      RA4 ******************
; 

Beep
        bcf         INTCON,7
        movlw       Cycle_4
        movwf       Cell_4 

Beep_500
        movlw       Cycle_3
        movwf       Cell_3        
Double
        movlw       Cycle_2
        movwf       Cell_2
H_Level
        bsf         PORTA,4
        movlw       Cycle_1
        movwf       Cell_1
Ring_1
        decfsz      Cell_1,f
        goto        Ring_1
L_Level
        bcf         PORTA,4
        movlw       Cycle_1
        movwf       Cell_1
Ring_2
        decfsz      Cell_1,f
        goto        Ring_2

        decfsz      Cell_2,f
        goto        H_Level
        
        decfsz      Cell_3,f
        goto        Double
        goto        Del_500

Del_500
        movlw       Cycle_3
        movwf       Cell_3        
Doub
        movlw       Cycle_2
        movwf       Cell_2
H_Lev
        bcf         PORTA,4
        movlw       Cycle_1
        movwf       Cell_1
Rin_1
        decfsz      Cell_1,f
        goto        Rin_1
L_Lev
        bcf         PORTA,4
        movlw       Cycle_1
        movwf       Cell_1
Rin_2
        decfsz      Cell_1,f
        goto        Rin_2

        decfsz      Cell_2,f
        goto        H_Lev
        
        decfsz      Cell_3,f
        goto        Doub
        
        decfsz      Cell_4,f
        goto        Beep_500
        bsf         INTCON,7
        return


;
;****     N *********
;             (.)

        ORG       0x300
Convert
        addwf     PCL,f
	retlw     .1
	retlw	  .1
	retlw     .1
	retlw     .2
        retlw	  .2
        retlw     .2
	retlw	  .3
	retlw	  .3
	retlw	  .3
	retlw	  .4
	retlw     .4
	retlw	  .4
	retlw     .5		
	retlw	  .5
	retlw	  .5
	retlw     .6
	retlw	  .6
	retlw	  .6
	retlw	  .7
	retlw     .7
	retlw	  .7
	retlw	  .8
	retlw     .8
	retlw	  .8
	retlw     .9
	retlw	  .9
	retlw	  .9
	retlw     .10
	retlw     .10
	retlw     .10
	retlw     .11
	retlw	  .11
	retlw     .11
	retlw     .12
	retlw     .12
	retlw     .12
	retlw	  .13
	retlw     .13
	retlw	  .13
	retlw	  .14
	retlw	  .14
	retlw	  .14
	retlw	  .15
	retlw	  .15
	retlw	  .15
	retlw	  .16
	retlw	  .16
	retlw     .16
	retlw     .17
	retlw	  .17
	retlw	  .17
	retlw	  .18
	retlw	  .18
	retlw	  .18
	retlw	  .19
	retlw	  .19
	retlw	  .19
	retlw	  .20
	retlw     .20
	retlw	  .20
	retlw	  .21
	retlw	  .21
 	retlw     .21
	retlw	  .22
	retlw	  .22
	retlw     .22
	retlw	  .23
	retlw	  .23
	retlw	  .23
	retlw	  .24
	retlw	  .24
	retlw     .24
	retlw	  .25
	retlw     .25 
	retlw	  .25
	retlw	  .26
	retlw	  .26
	retlw	  .26
	retlw     .27
	retlw     .27
	retlw	  .27
	retlw     .28
	retlw     .28
	retlw     .28
	retlw     .29
	retlw     .29
	retlw     .29
	retlw     .30
        retlw	  .30
	retlw	  .30
	retlw     .31
	retlw	  .31
	retlw     .31
	retlw     .32
	retlw     .32
	retlw	  .32
	retlw     .33
	retlw     .33
	retlw     .33
	retlw     .34
	retlw     .34
	retlw     .34
	retlw     .35
	retlw     .35
	retlw     .35
	retlw     .36
	retlw     .36
	retlw     .36
	retlw     .37
	retlw     .37
	retlw     .37
	retlw     .38
	retlw     .38
	retlw     .38
	retlw     .39
	retlw     .39
	retlw     .39
	retlw     .40
	retlw     .40
	retlw     .40
	retlw     .41
	retlw     .41
	retlw     .41
	retlw     .42
	retlw     .42
	retlw     .42
	retlw     .43
	retlw     .43
	retlw     .43
	retlw     .44
	retlw     .44
	retlw     .44
	retlw     .45
	retlw     .45
	retlw     .45
	retlw     .46 
	retlw     .46
	retlw     .46
        retlw     .47
        retlw     .47
	retlw     .47
	retlw     .48
	retlw     .48
	retlw     .48
	retlw     .49
	retlw     .49
	retlw     .49
	retlw     .50
	retlw     .50
	retlw     .50
	retlw     .51
	retlw     .51
	retlw     .51
	retlw     .52
	retlw     .52
	retlw     .52
	retlw     .53
	retlw     .53
	retlw     .53
	retlw     .54
	retlw	  .54
	retlw     .54
	retlw     .55
	retlw     .55
	retlw     .55
	retlw     .56
	retlw     .56
	retlw     .56
	retlw     .57
	retlw     .57
	retlw     .57
	retlw     .58
	retlw     .58
	retlw     .58
	retlw     .59
	retlw     .59
	retlw     .59
	retlw     .60
	retlw     .60
	retlw     .60
	retlw     .61
	retlw     .61
	retlw     .61
	retlw     .62
	retlw     .62
	retlw     .62
	retlw     .63
	retlw     .63
	retlw     .63
	retlw     .64
	retlw     .64
	retlw     .64
	retlw     .65
	retlw     .65
	retlw     .65
	retlw     .66
	retlw     .66
	retlw     .66
	retlw     .67
	retlw     .67
	retlw     .67
	retlw     .68
	retlw     .68
	retlw     .68
	retlw     .69
	retlw     .69
	retlw     .69
	retlw     .70
	retlw     .70
	retlw     .70
	retlw     .71
	retlw     .71
	retlw     .71
	retlw     .72
	retlw     .72
	retlw     .72
	retlw     .73
	retlw     .73
	retlw     .73
	retlw     .74
	retlw     .74
	retlw     .74
	retlw     .75
	retlw     .75
	retlw     .75
	retlw     .76
	retlw     .76
	retlw     .76
	retlw     .77
	retlw     .77
	retlw     .77
	retlw     .78
	retlw     .78
	retlw	  .78
	retlw     .79
	retlw     .79
	retlw     .79
	retlw     .80
	retlw     .80
	retlw     .80
	retlw     .81
	retlw     .81
	retlw     .81
	retlw     .82
	retlw     .82
	retlw     .82
	retlw     .83
	retlw     .83
	retlw     .83
	retlw     .84
	retlw     .84
	retlw     .84
	retlw     .85
	retlw     .85
	retlw     .85
   	         
	END                       ;  


